The Synthesis ToolKit in C++ (STK)

Home Information Classes Download Usage Mail List Requirements Links FAQ Tutorial

# RtMidiIn Class Reference

A realtime MIDI input class. More...

`#include <RtMidi.h>`

Inheritance diagram for RtMidiIn:

List of all members.

## Public Types
typedef void(* | RtMidiCallback )(double timeStamp, std::vector< unsigned char > *message, void *userData)
| User callback function type definition.
## Public Member Functions
| RtMidiIn (RtMidi::Api api=UNSPECIFIED, const std::string clientName=std::string("RtMidi Input Client"), unsigned int queueSizeLimit=100)
| Default constructor that allows an optional api, client name and queue size.
| ~RtMidiIn (void) throw ()
| If a MIDI connection is still open, it will be closed by the destructor.
RtMidi::Api | getCurrentApi (void) throw ()
| Returns the MIDI API specifier for the current instance of RtMidiIn.
void | openPort (unsigned int portNumber=0, const std::string portName=std::string("RtMidi Input"))
| Open a MIDI input connection.
void | openVirtualPort (const std::string portName=std::string("RtMidi Input"))
| Create a virtual input port, with optional name, to allow software connections (OS X and ALSA only).
void | setCallback (RtMidiCallback callback, void *userData=0)
| Set a callback function to be invoked for incoming MIDI messages.
void | cancelCallback ()
| Cancel use of the current callback function (if one exists).
void | closePort (void)
| Close an open MIDI connection (if one exists).
unsigned int | getPortCount ()
| Return the number of available MIDI input ports.
std::string | getPortName (unsigned int portNumber=0)
| Return a string identifier for the specified MIDI input port number.
void | ignoreTypes (bool midiSysex=true, bool midiTime=true, bool midiSense=true)
| Specify whether certain MIDI message types should be queued or ignored during input.
double | getMessage (std::vector< unsigned char > *message)
| Fill the user-provided vector with the data bytes for the next available MIDI message in the input queue and return the event delta-time in seconds.

## Detailed Description

A realtime MIDI input class.

This class provides a common, platform-independent API for realtime MIDI input. It allows access to a single MIDI input port. Incoming MIDI messages are either saved to a queue for retrieval using the getMessage() function or immediately passed to a user-specified callback function. Create multiple instances of this class to connect to more than one MIDI device at the same time. With the OS-X and Linux ALSA MIDI APIs, it is also possible to open a virtual input port to which other MIDI software clients can connect.

by Gary P. Scavone, 2003-2012.

## Constructor & Destructor Documentation

RtMidiIn::RtMidiIn | ( | RtMidi::Api | api = `UNSPECIFIED`,
|  | const std::string | clientName = `std::string("RtMidi Input Client")`,
|  | unsigned int | queueSizeLimit = `100` |
| ) |  |  |

Default constructor that allows an optional api, client name and queue size.

An exception will be thrown if a MIDI system initialization error occurs. The queue size defines the maximum number of messages that can be held in the MIDI queue (when not using a callback function). If the queue size limit is reached, incoming messages will be ignored.

If no API argument is specified and multiple API support has been compiled, the default order of use is JACK, ALSA (Linux) and CORE, Jack (OS-X).

## Member Function Documentation

void RtMidiIn::openPort | ( | unsigned int | portNumber = `0`,
|  | const std::string | portName = `std::string( "RtMidi Input" )` |
| ) |  |  | `[inline, virtual]`

Open a MIDI input connection.

An optional port number greater than 0 can be specified. Otherwise, the default or first port found is opened.

Implements RtMidi.

    00427 { return rtapi_->openPort( portNumber, portName ); }

void RtMidiIn::openVirtualPort | ( | const std::string | portName = `std::string( "RtMidi Input" )` | ) | `[inline, virtual]`

Create a virtual input port, with optional name, to allow software connections (OS X and ALSA only).

This function creates a virtual MIDI input port to which other software applications can connect. This type of functionality is currently only supported by the Macintosh OS-X and Linux ALSA APIs (the function does nothing for the other APIs).

Implements RtMidi.

    00428 { return rtapi_->openVirtualPort( portName ); }

void RtMidiIn::setCallback | ( | RtMidiCallback | callback,
|  | void * | userData = `0` |
| ) |  |  | `[inline]`

Set a callback function to be invoked for incoming MIDI messages.

The callback function will be called whenever an incoming MIDI message is received. While not absolutely necessary, it is best to set the callback function before opening a MIDI port to avoid leaving some messages in the queue.

    00430 { return rtapi_->setCallback( callback, userData ); }

void RtMidiIn::cancelCallback | ( | void |  | ) | `[inline]`

Cancel use of the current callback function (if one exists).

Subsequent incoming MIDI messages will be written to the queue and can be retrieved with the getMessage function.

    00431 { return rtapi_->cancelCallback(); }

std::string RtMidiIn::getPortName | ( | unsigned int | portNumber = `0` | ) | `[inline, virtual]`

Return a string identifier for the specified MIDI input port number.

An empty string is returned if an invalid port specifier is provided.

Implements RtMidi.

    00433 { return rtapi_->getPortName( portNumber ); }

void RtMidiIn::ignoreTypes | ( | bool | midiSysex = `true`,
|  | bool | midiTime = `true`,
|  | bool | midiSense = `true` |
| ) |  |  | `[inline]`

Specify whether certain MIDI message types should be queued or ignored during input.

o By default, MIDI timing and active sensing messages are ignored during message input because of their relative high data rates. MIDI sysex messages are ignored by default as well. Variable values of "true" imply that the respective message type will be ignored.

    00434 { return rtapi_->ignoreTypes( midiSysex, midiTime, midiSense ); }

double RtMidiIn::getMessage | ( | std::vector< unsigned char > * | message | ) | `[inline]`

Fill the user-provided vector with the data bytes for the next available MIDI message in the input queue and return the event delta-time in seconds.

This function returns immediately whether a new message is available or not. A valid message is indicated by a non-zero vector size. An exception is thrown if an error occurs during message retrieval or an input connection was not previously established.

    00435 { return rtapi_->getMessage( message ); }

The documentation for this class was generated from the following file:

- RtMidi.h

The Synthesis ToolKit in C++ (STK)
©1995-2012 Perry R. Cook and Gary P. Scavone. All Rights Reserved.